<template>
    <div class="main-container">
        <el-menu mode="horizontal" :ellipsis="ellipsisCondition">
            <el-menu-item>
                <button class="menu" @click="toggleMenu"
                    onclick="this.classList.toggle('opened');this.setAttribute('aria-expanded', this.classList.contains('opened'))"
                    aria-label="Main Menu">
                    <svg width="24px" height="56px" viewBox="0 0 100 100">
                        <path class="line line1"
                            d="M 20,29.000046 H 80.000231 C 80.000231,29.000046 94.498839,28.817352 94.532987,66.711331 94.543142,77.980673 90.966081,81.670246 85.259173,81.668997 79.552261,81.667751 75.000211,74.999942 75.000211,74.999942 L 25.000021,25.000058" />
                        <path class="line line2" d="M 20,50 H 80" />
                        <path class="line line3"
                            d="M 20,70.999954 H 80.000231 C 80.000231,70.999954 94.498839,71.182648 94.532987,33.288669 94.543142,22.019327 90.966081,18.329754 85.259173,18.331003 79.552261,18.332249 75.000211,25.000058 75.000211,25.000058 L 25.000021,74.999942" />
                    </svg>
                </button>
            </el-menu-item>
            <el-menu-item>JAT'S BATASAN PANCITERIA</el-menu-item>
            <div style="flex-grow: 1" />

            <el-menu-item class="toggle-dark" style="height: auto; padding: 0">
                <el-button @click="toggleDark()" style="height: 46px">
                    <img style="width: 20px" :src="isDark ? `/svg/moon.svg` : `/svg/sun.svg`" alt="SVG" />
                </el-button>
            </el-menu-item>

            <el-sub-menu>
                <template #title>
                    <el-icon>
                        <User />
                    </el-icon>
                    <span id="user-name">{{ data?.name }}</span>
                </template>
                <el-menu-item-group>
                    <el-menu-item index="1-1" @click="manageAccount">Account</el-menu-item>
                    <el-menu-item index="1-2" @click="performLogout">Logout</el-menu-item>
                </el-menu-item-group>
            </el-sub-menu>
        </el-menu>

        <el-container class="layout-container-demo">
            <el-aside class="side-bar-menu" style="position: absolute; z-index: 999">
                <el-scrollbar>
                    <el-menu :default-active="sideBarActive.toString()" class="el-menu-vertical-demo"
                        :collapse="isCollapse">
                        <template v-for="(item, index) in menuItems" :key="index">
                            <el-menu-item v-if="!item.children" :index="index.toString()"
                                @click="navigateTo(index, item.route)">
                                <el-icon>
                                    <component :is="item.icon" class="icon"></component>
                                </el-icon>
                                <span>{{ item.title }}</span>
                            </el-menu-item>

                            <el-sub-menu v-if="item.children" :index="index">
                                <template #title>
                                    <el-icon>
                                        <component :is="item.icon" class="icon"></component>
                                    </el-icon>
                                    <span>{{ item.title }}</span>
                                </template>
                                <el-menu-item-group>
                                    <template #title><span>{{
                                        item.children[0].title
                                    }}</span></template>
                                    <el-menu-item v-for="(child, childIndex) in item
                                        .children[0].children" :key="index + '-' + (childIndex + 1)"
                                        :index="index + '-' + (childIndex + 1).toString()" @click="
                                            navigateTo(
                                                index + '-' + (childIndex + 1),
                                                child.route
                                            )
                                            ">
                                        {{ child.title }}
                                    </el-menu-item>
                                </el-menu-item-group>
                            </el-sub-menu>
                        </template>
                    </el-menu>
                </el-scrollbar>
            </el-aside>

            <el-container>
                <el-main>
                    <slot></slot>
                </el-main>
            </el-container>
        </el-container>
    </div>
</template>

<style lang="scss" scoped>
.user-name {
    width: 150px;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
}

.toggle-dark:hover {
    background-color: transparent !important;
}

.icon {
    display: inline-block;
    max-width: 15px;
    max-height: 15px;
    transform: scale(1.5);
    margin-right: 0.5rem;
}

.el-menu-vertical-demo {
    background-color: var(--el-menu-bg);
}

.menu {
    background-color: transparent;
    border: none;
    cursor: pointer;
    display: flex;
    padding: 0;
}

.line {
    fill: none;
    stroke: var(--el-color-primary);
    stroke-width: 6;
    transition: stroke-dasharray 600ms cubic-bezier(0.4, 0, 0.2, 1),
        stroke-dashoffset 600ms cubic-bezier(0.4, 0, 0.2, 1);
}

.line1 {
    stroke-dasharray: 60 207;
    stroke-width: 6;
}

.line2 {
    stroke-dasharray: 60 60;
    stroke-width: 6;
}

.line3 {
    stroke-dasharray: 60 207;
    stroke-width: 6;
}

.opened .line1 {
    stroke-dasharray: 90 207;
    stroke-dashoffset: -134;
    stroke-width: 6;
}

.opened .line2 {
    stroke-dasharray: 1 60;
    stroke-dashoffset: -30;
    stroke-width: 6;
}

.opened .line3 {
    stroke-dasharray: 90 207;
    stroke-dashoffset: -134;
    stroke-width: 6;
}
</style>

<script setup>
import { ref, onMounted } from "vue";
import { useRoute, useRouter } from "vue-router";
import { ElMessageBox } from "element-plus";
import userHandler from "../helpers/userHandler";
import { useDark, useToggle } from "@vueuse/core";
import { Odometer, User, Tickets } from "@element-plus/icons-vue";
import userValidator from "../helpers/userValidator";

const { loading, getUserData, logout } = userHandler;
const { validateEmail, validateToken } = userValidator;
const route = useRoute();
const router = useRouter();
const isCollapse = ref(true);
const ellipsisCondition = ref(false);

const isDark = useDark();
const toggleDark = useToggle(isDark);
const loadingInstance = ref(null);
const data = ref();
const sideBarActive = ref(0);

const toggleMenu = () => {
    isCollapse.value = !isCollapse.value;
    let sideBar = document.querySelector(".side-bar-menu");
    if (isCollapse.value) {
        sideBar.style.zIndex = -1;
    } else {
        sideBar.style.zIndex = 3;
    }
};

const menuItems = [
    { icon: Odometer, title: "Dashboard", route: "/" },
    { icon: Tickets, title: "View Orders", route: "/vieworders" }
];

const manageAccount = () => {
    router.push('/account-user');
}

const performLogout = () => {
    ElMessageBox.confirm(
        "Are you sure you want to logout your account?",
        "Warning",
        {
            confirmButtonText: "OK",
            cancelButtonText: "Cancel",
            type: "warning",
        }
    )
        .then(async () => {
            const URL_logout = "/api/logout";
            await logout(URL_logout, router);
        })
        .catch((error) => {
            console.log(error);
        });
};

const navigateTo = (index, route) => {
    localStorage.setItem("sideBarActive", index.toString());
    sideBarActive.value = index.toString();
    router.push(route);
};

window.addEventListener("resize", function (event) {
    if (parseInt(document.body.clientWidth) < 400) {
        ellipsisCondition.value = true;
    } else {
        ellipsisCondition.value = false;
    }
});

onMounted(async () => {
    sideBarActive.value = localStorage.getItem("sideBarActive");
    let sideBar = document.querySelector(".side-bar-menu");
    sideBar.style.zIndex = -1;
    await validateEmail(router, route);
    await getUserData(data);
    await validateToken(router);

    sessionStorage.setItem('user_id', data.value.id);
});
</script>
